 


function whereyoubeen(urlsToCheck,path_to_savelinks){

  // If we have no links to check ...
  if(urlsToCheck.length == 0){
    // ... just bail.
    return;
  }

  // So we have links to check and don't like to write 'jQuery' over
  // and over again so we shorten it to $.
  $=jQuery; 


  // To organize links a bit we build a hidden ul so that we can
  // append the links to test.
  $('body')
    .append("<ul id='silent_append'></li>");
  

  // Lets create a closure to append links to ...
  function appendLink(href,id){
    // ... append a link to #silent_append.

    // @param string href - link's href
    //
    // @param string id - the id of li that holds the link. If its
    // not set a random id will be choosen
    //
    // Returns id which may have been generated randomly
    
    // We are going to use the id later to find css and to remove,
    // so lets create one if we don't have one
    if(!id){
      id=Math.floor(Math.random()*10000);
    }
    
    // A modest, but proud, link is created here.
    var link = 
    '<a id="' +id+ '" href="'
      +href+'">'+href+'</a>';
    
    // Place that link in the id="silent_append" ul where it will be
    // easy to get to.
    $("#silent_append")
      .append('<li style="display:block;" id="li_' +id+ '">'+link+'</li>');	       
    
    return id;
  }// appendLink
  


  // We are going to see what the css color is for a URL that has not
  // been visted, so here is a URL that hasn't been visted.
  var noVisited = 
    'http://' + 
    Math.floor(Math.random()*1000000) +  
    ".com";
  
  // Now if we append a link we havn't visted and one that we have
  // visited then ...
  appendLink(document.location,"yes_visted");
  appendLink(noVisited,'no_visted');

  // ... we can calibrate using the links color to see what the colors
  // are for visited and unvisited links.
  var yesVisitedColor =
    $("#yes_visted").css("color");
  var noVisitedColor = 
    $("#no_visted").css("color");

  // If those colors are the same ...
  if(yesVisitedColor == noVisitedColor){
    // ... then just forget about it, your css is crap, i am going
    // home.
    return; 
  }

  // Remove the elements from the dom to keep the site moving
  // zippy.
  $("#li_yes_visted").remove();
  $("#li_no_visted").remove();


  // We need a place to store links that have been visited, lets use an
  // array()
  var visited=Array();

  // now foreach of the links to check ...
  for(i in urlsToCheck){
    // ... append them to our ul so that we can ...
    idOfString=appendLink(urlsToCheck[i]);

    // check there color against the visited color and ...
    var curColor=$("#" + idOfString).css("color")
    if(curColor == yesVisitedColor){
      // ... if it matches we append it to the visited array.
      visited[visited.length]=urlsToCheck[i];
    }

    // we won't be needing that link clogging up the dom anymore so
    // lets remove it.  
    $("#li_" + idOfString).remove();
  }// for urlsToCheck

  // We then send our results off to the database via PHP.
  $.ajax({
    type: "POST",
    url: path_to_savelinks,
    data: {'visited': visited.join("|||")},
    success: function(data){
      // you could uncomment this if you wanted savelinks to say
      // something, or maybe send back and XML object 
      //$('body').append("<pre>" + data + "</pre>");
    }
  });

  // finally we return visited so it can be used to affect the dom
  return visited;
};
