<?php
/*
  @file: wyb_header.inc.php - prints the whereyoubeen javascript. This
    file should be included in the page you want to check. Using
    something like


         // If you are already using jquery, set this to True
         $ALREAY_HAVE_JQUERY=False;
         // would be www.example.com/whereyoubeen/
         $WYB_PATH="/whereyoubeen"; 
         // this includes the header
         include($_SERVER['DOCUMENT_ROOT'] .
          "$WYB_PATH/wyb_header.inc.php"); 


 
  @author: Victory
  @site: http://dfhu.org/blog/
  @version: 1.0
  @date: 090721
  @license: BSD

 */

// A better check would be to see if $_COOKIES are set, but that would
// require a set page and a check page, until then just check to see
// if this is a Mozilla/Opera/Safari browser but if not ...
if(!preg_match("/^(Mozilla|Opera)/",$_SERVER['HTTP_USER_AGENT'])){
  // ... bail.
  echo $_SERVER['HTTP_USER_AGENT'];
  return;
}

// construct the that path to whereyoubeen on the server
$WYB_ABS_PATH=
  $_SERVER['DOCUMENT_ROOT'] . 
  "$WYB_PATH/";

// open up the sqlite database;
$db=new PDO("sqlite:$WYB_ABS_PATH/db/wyb.sqlite");

// Now, Check to see if the user's IP is in the users table by ...
$sql="
SELECT
 rowid
FROM 
 users
WHERE
 remote_addr=:remote_addr
 ";
// ... preparing and ...
$stmt=$db->prepare($sql);
// ... excuting the the $sql statment using the users IP address.
$stmt->execute(Array(":remote_addr"=>$_SERVER['REMOTE_ADDR']));

// if the user's ip is in the database ...
if($stmt->fetch()){
  // ... return and don't run any tests.
  return;
}

// So now that we decided we are going to go ahead with the tests,
// lets ensure that the jquery variable is set.
if(!isset($ALREADY_HAVE_JQUERY)){
  $ALREADY_HAVE_JQUERY=False;
}

// If we need jquery ...
if(!$ALREADY_HAVE_JQUERY){
  // ... then print the script element to include it.
echo "
<script 
  type=\"text/javascript\" 
  src=\"$WYB_PATH/js/jquery-1.3.2.min.js\"></script>
";
}

// Print the include statament for whereyoubeen.js which contains the
// logic to check which sites the user has been to.
echo "
<script 
  type=\"text/javascript\"
  src=\"$WYB_PATH/js/whereyoubeen.js\"></script>
";
?>

<style type="text/css">
// set up different colors for visited/non visited links
ul#silent_append a{
color: #F00 !important;
}
ul#silent_append a:visited{
color: #00F !important;
}
</style>

<script type="text/javascript">

<?php
  // If you already have jquery in your page, then don't mess with
  // your preference for conflict.
  if(!$ALREADY_HAVE_JQUERY){
    echo "jQuery.noConflict();";
  }

// Wait for the document to be ready ...
?>
jQuery(document).ready(function(){
  
  <?php
    // .. and when it is we need to need the urls to check.  Including
    // wyb_urls_get.php will produce the a javascript parsable list of
    // quoted urls. We store that array in utc (Urls To Check).
  ?>
  var utc = 
    [<?php 
     include($_SERVER['DOCUMENT_ROOT'] . 
             "$WYB_PATH/wyb_urls_get.php"); 
     ?>];
  
  <?php
    // For all the links in utc, check to see if they are in the
    // user's history. This is done by checking the color of the
    // links as rendered in a hidden element of the dom.
  ?>
  var visited=
    whereyoubeen(
      utc,
      '<?php echo $WYB_PATH; ?>/wyb_urls_save.php');

  <?php

  // You could also use 'visited' here to change the DOM, for instance
  // create a meta redirect, or place a "Warning About Competitor,"
  // popup on the page and so on.

  ?>
});

</script>
