<?php

/* 
   @file: wyb_urls_get.php - Cut and paste links to check in
   $list_of_urls string below. This will allow direct cut and paste in
   case you want to separte the big list of links to check from this
   little one. 
   
   
   @author: Victory
   @site: http://dfhu.org/blog/
   @version: 1.0
   @date: 090721
   @license: BSD

 */


// Cut and paste links here. One link per line, links may not contain
// the quote charters " or ', they should be fully qualified.

$list_of_urls="

http://dfhu.org/blog/index.php
http://www.bing.com/
http://www.whycanttoryread.com/

";


// This is the path on the server for whereyoubeen includes, etc ....
$WYB_ABS_PATH=
  $_SERVER['DOCUMENT_ROOT'] . 
  "$WYB_PATH/";

// Get the conf file which defines MAX_NUM_LINKS
include("$WYB_ABS_PATH/wyb_conf.inc.php");



function url_clean($url){
 
  // We want to add a "/" to the back of urls which do not have them
  // which this funciton may do, or it may have bugs, if you post your
  // urls correctly, this function will work.

  // trim the $url
  $url=trim($url);

  // then if you need a "/" ...
  if(!preg_match(";[a-zA-Z]/.*$;",$url)){
    // ... then add it to the end. 
    $url .= "/";
  }
  return $url;
}


function listify_urls($list_of_urls, &$url_list,&$limit){
  // Take a list of urls as a string and pack them into url_list.
  // @param string $list_of_urls - a string with urls, one per line.
  // @param& array $url_list - the array to pack $urls into.
  // @param &int $limit - the maximum number of links that can be
  //   added to $url_list

  // Take the list as a string and break it up by line so that we can
  // clean each line ...
  $urls=array_map('url_clean',explode("\n",$list_of_urls));
  // If we find any lines that don't seem to be URLS then filter them
  // out of the list.
  $urls=array_filter($urls,'url_check');


  // for each of the urls see add it to the url_list (which is
  // actually an array). Of course if we the limit goes down to zero,
  // then we need to exit.
  foreach($urls as $url){

    if($limit-- <= 0){
      return;
    }

    $url_list[]="'" . $url . "'";

  }

  // we don't return url_list, because its pasted by reference.

}

// set the limit
$limit=MAX_NUM_LINKS;
$url_list=Array();

// That the list of urls as a string and store the limited number of
// them to the $url_list array
listify_urls($list_of_urls,
	     $url_list,
	     $limit);

// snag the contents from "universal" list of domains to check.
listify_urls(file_get_contents("$WYB_ABS_PATH/wyb-sites-to-check.txt"),
	     $url_list,
	     $limit);

// take out any duplicates from the list to speed up the javascript.
$url_list=array_unique($url_list);


// You could use this time to pack the urls into a _SESSION or _COOKIE
// Variable so that you could change the layout of subsequent page
// views to reflect interests.
//
// session_start()
// foreach($url_list as $i=>$url){ $_SESSION["url_$i"] = $url; };

// now just print the list as javascript list.
echo implode(",\n",$url_list);
?>