<?php
/*
  
  @file: wyb_urls_save.php, Puts visited sites in a SQLite
    database. 
    
  @param $_POST['visited'] - The urls are passed via
    $_POST['VISITED'], which is a string of URLs delimited by three
    bars "|||"

  @author: Victory
  @site: http://dfhu.org/blog/
  @version: 1.0
  @date: 090721
  @license: BSD

 */


echo "NARWALS? ";


// the conf has the url_check function , which checks to see if the
// url is valid.
require('./wyb_conf.inc.php');

// explode the string of visited websites and check to make sure that
// they are in fact valid urls. This will limit the kind of pollution
// you could get from deviant users.
$urls=
  array_filter(
   explode("|||",
	   $_POST['visited']),
   'url_check');


// Open up the database so that we can ... 
$db=new PDO("sqlite:db/wyb.sqlite");


// ... prepare to insert ...
$sql="
INSERT INTO 
 users
  (remote_addr,remote_host)
 VALUES
  (:remote_addr,:remote_host)
";
$stmt=$db->prepare($sql);

// the remote_host and remote_addr by ...
$user=Array();
$user[":remote_addr"]=$_SERVER['REMOTE_ADDR'];
$user[":remote_host"]=
  isset($_SERVER['REMOTE_HOST']) ? $_SERVER['REMOTE_HOST'] : "";

try{
  // excuting the the statment with our user data, but ...
  $stmt->execute($user);
}
catch(Exception $e){
  // .. if that doesn't work for whatever reason we bail. The normal
  //reason being a the the remote_addr is already in the users
  //database, so we should be storing that info again.  print $e;
  exit;
}

// Now we are alive and we don't know anything about the user so we
// prepare to insert the user's info into the whereyoubeen table ...
$sql="
INSERT INTO 
 whereyoubeen
  (remote_addr,remote_host,user_agent,url)
 VALUES
  (:remote_addr,:remote_host,:user_agent,:url)
";
$stmt=$db->prepare($sql);

// insert the user agent if its set, otherwise just ""
$user[":user_agent"]=
  isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : "";

// Finally, for each of the urls, insert them into the db, along with
// the user_agent, ip and host.
foreach($urls as $url){
  $user[':url']=$url;  
  $stmt->execute($user);

}

echo "<i>F YEAH!</i>";
?>