<?php
/*
  @author: Victory
  @site: http://dfhu.org/blog
  @version: (Proof of Concept, Not Good Coding Style)
  @license: BSD
 */


// We pull the conf because it contains the STATS_PASSWORD
require('./wyb_conf.inc.php');


// start a session, this script requires Cookies.
session_start();


// See if all we want to do is logout, because if we do then ...
if(isset($_GET['logout'])){
  // ... unset logged in flag and ...
   unset($_SESSION['is_logged_in']);
   // redirect to the homepage.
   header("Location: /");
   exit;
}

// OK, we are not logging out, so check to see if we are logging in
// and if we have the correct credentials ...
if(isset($_POST['stats_pass']) 
   and $_POST['stats_pass'] == STATS_PASSWORD){
  // ... then set the 'logged in' flag
  $_SESSION['is_logged_in']=True;
}

// Remind the user if she has not changed the default password, this
// is a bad idea ...
if(STATS_PASSWORD == 'pr00f'){
  $msg="
<p>You are still using the default password 'pr00f' please change this
by editing wyb_conf.inc.php with a text editor.</p>
";
}

// If we have gotten this far and they still are not logged in, then
// we need to ...
if(!isset($_SESSION['is_logged_in']) 
   or !$_SESSION['is_logged_in']){ 

  // ... ask for credentials.
  ?>
<html><head><title>Loggin</title></head><body>
<div style="padding: 50px; margin-top: 100px">
<form action="wyb_stats.php" method="POST">
<label for="stats_pass">Password</title>
<input type="password" name="stats_pass">
<?php echo $msg;?>
</form>
<p>Note You Need Cookies enabled to use this script</p>
</div>
</body>
</html>

<?php
exit;
}


function display_distribution($stmt,$msg){
  // A trivial display of stats.

  // @param PDO:Statment $stmt - A prepared statment which can be
  //   fetched from, the resulting row must set url,count,percentage

  // @param string $msg - A message/explanation to print.

  echo "<h2>$msg:</h2>" . 
  '<table>
  <thead>
   <th>Count</th>
   <th>Percentage</th>
   <th>Url</th>
  </thead>
  <tfoot>
  <tr>
   <td colspan="3">
     
   </td>
  </tr>
  </tfoot>
  <tbody>
  ';

  // while there are more rows to be fetched from the statment ...
  while($row=$stmt->fetch()){ 
    // ... clean up the url just in case.
    $url=str_replace("<","&lt",$row["url"]);    
    $link="<a href=\"$url\">$url</a>";

    // now just print the row in a prettier way.
    echo "
    <tr>
     <td>{$row['count']}</td>
     <td>" .  
      sprintf("%0.2f", floatval($row['percentage'])) .
     "</td>
     <td>" . $link . "</td>
    </tr>
    ";
  }
 
  // finally just close up the table.
  echo '
  </tbody>
  </table>
  ';
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" 
    "http://www.w3.org/TR/html4/loose.dtd">
<html>

<head>
<title>WYB Basic Stats</title>
<link rel="stylesheet" href="style.css" >
<meta http-equiv="content-type" content="text/html; charset=utf-8">

<style type="text/css">

h2{
 font-size: 20px;
 padding-bottom: 1px;
 margin-bottom: 1px;
 width: 90%; 
 background-color: #AAC;
}

h1{
 font-size: 25px;
}
th{
 border-bottom: 1px solid #FFF;
}

td{
 border-bottom: 1px solid #000;
}

p{
width: 50%;
margin: 10px auto 10px auto;
}

table{
 width: 90%; 
 background-color: #DDE;
}
</style>

</head>
<body>

<h1>Where You Been Stats Proof of Concept</h1>

<p>

This is page is just a proof of concept. It shows the distribution of
urls viewed by visitors who have seen any of the pages in your
list. Visitors who have not seen any pages in your list are not
considered. <a href="wyb_stats.php?logout=True">Logout</a>

</p>


<?php

  // open up the wyb database
$db=new PDO("sqlite:db/wyb.sqlite");
$db->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);

// create a VIEW of distinct visitors
$sql="
CREATE TEMP VIEW unique_visitors AS
 SELECT DISTINCT 
  url,remote_addr 
 FROM whereyoubeen
";
$db->query($sql);


// Get the url, the number of users have seen the each url, and then
// that count as a percentage of the total.
$sql="
SELECT
 url,
 COUNT(url) AS count,
 COUNT(url)*100.0/(SELECT COUNT(*) FROM unique_visitors)
  AS percentage
FROM
 unique_visitors
WHERE
 remote_addr != :my_remote_addr 
GROUP BY
 url
ORDER BY
 percentage DESC
";
$stmt=$db->prepare($sql);
$prms=Array(":my_remote_addr"=>$_SERVER['REMOTE_ADDR']);
$stmt->execute($prms);
display_distribution($stmt,"Unique Visitors");

// same as above but do not differentiate between non-unique IPs
$sql="
SELECT
 *,
 COUNT(url) AS count,
 COUNT(url)*100.0/(SELECT COUNT(*) FROM whereyoubeen)
  AS percentage
FROM
 whereyoubeen
WHERE
 remote_addr != :my_remote_addr 
GROUP BY
 url
ORDER BY
 percentage DESC
";
$stmt=$db->prepare($sql);
$stmt->execute($prms); // $prms is set above
display_distribution($stmt,"Non Unique");

?>

<p> 

To clear the database visit <a href="wyb_makedb.php">wyb_makedb.php</a>. 
If you do not wish to lose your data then you should backup your
database before visiting that link.
  
</p>


<p>

Features can be added to this to make it much more telling. We may be
able to estimate Age, Sex, Income, Ethnicity and so on given the
correct pages. For more advanced working of the data you should
contact victory@dfhu.org to ask for a quote.

</p>

<p>
<a href="wyb_stats.php?logout=True">Logout</a>
</p>


</body>
</html>
